const co = require('co')
const prompt = require('co-prompt')
const chalk = require('chalk')
const TEMPLATES = require('../lib/templates')
const downTemplates = require('./down-templates')
let NameArray = {}
let PathArray = {}

module.exports = function (name) {
  getTemps(TEMPLATES)
  co(generator(name))
}

function getTemps (templates) {
  for (let key in templates.list) {
    let item = templates.list[key]
    NameArray[key] = item.name
    PathArray[item.name] = item.path
  }
}

let generator = function * (name) {
  let tempName = name
  let path = PathArray[name]

  /**
   * 判断下载是否存在
   */
  if (!name || !path) {
    console.log('可用模板列表:')
    for (let key in NameArray) {
      let tempName = NameArray[key]
      console.log(
        '     ' + chalk.green(key) +
        ' : ' + chalk.green(tempName))
    }

    tempName = yield prompt('请选择模板类型:')
    path = PathArray[NameArray[tempName]]
  }

  /**
   * 调用对应的方法
   */
  if (NameArray[tempName] || PathArray[tempName]) {
    console.log('----------------------------------------')
    let projectName = yield prompt('请输入项目名称(demo):')

    if (!projectName) {
      projectName = 'demo'
    }

    let initGitlab = yield prompt('是否初始化Gitlab仓库(Y/N,默认Y):')

    if (!initGitlab) {
      initGitlab = 'Y'
    }

    console.log('----------------------------------------')
    //console.log(path)

    downTemplates(path, projectName, initGitlab)
  } else {
    console.log(chalk.red(`✘模版[${tempName}]不存在`))
    process.exit(0)
  }
}
