const fs = require('fs');
const config = require('../bin/aif-tool-config');

/**
 * 获取本地缓存的用户信息
 *
 * @returns {string}
 */
const getAifToolConfig = function () {
  let aifToolConfig = config.AIFTEMPLATELIST;

  // 文件存在读取配置
  if (fs.existsSync(config.AIFTOOLCONFIG)) {
    aifToolConfig = JSON.parse(fs.readFileSync(config.AIFTOOLCONFIG).toString());
  } else {
    // 文件夹不存在，则读取配置
    !fs.existsSync(config.AIFTOOLCONFIGHOME) && fs.mkdirSync(config.AIFTOOLCONFIGHOME);
    fs.writeFileSync(config.AIFTOOLCONFIG, JSON.stringify(aifToolConfig));
  }

  return aifToolConfig;
};

module.exports = {
  list: getAifToolConfig(),
  getAifToolConfig,
};
