const chalk = require('chalk')
const figlet = require('figlet');
const PACKAGE = require('../package');

/**
 * Print banner
 * Font preview：http://patorjk.com/software/taag/#p=display&f=3D-ASCII&t=feflow%0A
 *
 */
function printBanner() {
  figlet.text('aif-tool', {
    font: '3D-ASCII',
    horizontalLayout: 'default',
    verticalLayout: 'default'
  }, function (err, data) {
    if (err) {
      console.info('Something went wrong...');
      console.error(err);
      return;
    }

    console.log(chalk.cyan(data));
    console.log(chalk.cyan(` AIF-TOOL，当前版本v${PACKAGE.version}, 让开发工作流程更简单，主页: http://wiki.tongdun.me/pages/viewpage.action?pageId=25412919`));
    console.log(chalk.cyan(' (c) powered by AIF Team'));
    console.log(chalk.cyan(' Run aif-tool --help to see usage.'));
  });
}

printBanner()
